Index: wiki/Manual.wiki
===================================================================
--- wiki/Manual.wiki	(revision 19)
+++ wiki/Manual.wiki	(revision 20)
@@ -5,5 +5,5 @@
 = Introduction =
 
-XTIDE Universal BIOS is mainly used with XTIDE controller that makes possible to use modern IDE drives on PC/XT systems. XTIDE Universal BIOS does more than that since it support 16- and 32-bit transfers too. 16-bit transfers are meant for 16-bit ISA controllers and 32-bit transfers are meant for VLB and PCI controllers.
+XTIDE Universal BIOS is mainly used with [http://wiki.vintage-computer.com/index.php/XTIDE_project XTIDE controller] to use modern IDE drives on PC/XT systems. XTIDE Universal BIOS supports 16- and 32-bit IDE controllers found in later ISA, VLB and PCI systems. Thus XTIDE Universal BIOS can be used to overcome 504 MiB hard disk size limit that many old BIOSes have.
 
 
@@ -11,9 +11,13 @@
 
 Some of the features included in XTIDE Universal BIOS are...
-  * Boot menu for selecting any floppy drive or hard disk to boot from
+  * Supports up to 5 IDE controllers (10 drives)
+  * Accesses up to 8.4 GB hard disk space (BIOS CHS limit)
   * Block mode transfers
+  * Hard disk autodetection
+  * Autodetected CHS parameteres can be overridden to make drive appear smaller than it is
+  * Boot menu for selecting any floppy drive or hard disk to boot from, including hard disks that are not handled by XTIDE Universal BIOS
   * Compact Flash and Microdrive support
   * Support for most 8-, 16-, and 32-bit IDE controllers
-  * Using IRQ is optional
+  * IRQ and polling operation modes
 ...and many more.
 
@@ -35,5 +39,5 @@
 == Hardware supporting XTIDE Universal BIOS ROM ==
 
-The most convenient way to use XTIDE Universal BIOS is to use XTIDE card. It can be used on any PC with free 8-bit ISA slot. You might not want to connect any drives to it in 16- or 32-bit systems since 8-bit transfer will be very very slow. Using XTIDE card allows EEPROM flashing so it is really easy to update XTIDE Universal BIOS.
+The most convenient way to use XTIDE Universal BIOS is to use [http://wiki.vintage-computer.com/index.php/XTIDE_project XTIDE card]. It can be used on any PC with free 8-bit ISA slot. You might not want to connect any drives to it in 16- or 32-bit systems since 8-bit transfer will be very slow. Using XTIDE card allows EEPROM flashing so it is really easy to update XTIDE Universal BIOS.
 
 Another option is to use any card with free ROM socket for 8 kiB or larger ROMs. Official XTIDE builds are meant for 8 kiB ROMs but you can burn it on larger ROM if you append enough zeroes to the end (only append zeroes so checksum does not change). Many network cards have unused ROM sockets but there are also few multi I/O cards and IDE controllers with ROM sockets.
@@ -55,5 +59,5 @@
 = Using IDECFG.COM (XTIDE Universal BIOS configuration and flashing program) =
 
-Idecfg.com is intended to be user friendly. At the bottom of the screen appears quick information for each menu item. It can be hidden with F2 to make menu navigation faster for XT systems. Pressing F1 displays more detailed help for menu item. Sometimes the help is the same as the quick information but not always. Up, Down, PgUp, PgDn, Home and End keys are used for menu navigation. Enter selects menuitem and Esc resumes to previous menu.
+Idecfg.com is intended to be user friendly. At the bottom of the screen appears quick information for each menu item. It can be hidden with F2 to make menu navigation faster on XT systems. Pressing F1 displays more detailed help for menu item. Sometimes the help is the same as the quick information but not always. Up, Down, PgUp, PgDn, Home and End keys are used for menu navigation. Enter selects menuitem and Esc resumes to previous menu.
 
 Some menu items appear only when needed to make configuring easier.
@@ -110,11 +114,11 @@
      8-bit ISA controllers with one data port.
     * 16-bit
-     16-bit I/O for ISA (16-bit), VLB and PCI controllers.
+     ISA (16-bit) but it also works on VLB and PCI controllers.
     * 32-bit generic
      Generic 32-bit I/O for VLB and PCI controllers.
   * Base (cmd block) address
-   IDE controller command block address is the usual address mentioned for IDE controllers. By default the primary IDE controller uses port 1F0h and secondary controller uses port 170h. XTIDE uses port 300h by default.
+   IDE controller command block address is the usual address mentioned for IDE controllers. By default the primary IDE controller uses port 1F0h and secondary controller uses port 170h. XTIDE card uses port 300h by default.
   * Control block address
-   IDE controller control block address is normally command block address + 200h. For XTIDE the control block registers are mapped right after command block registers so use command block address + 8h for XTIDE.
+   IDE controller control block address is normally command block address + 200h. For XTIDE card the control block registers are mapped right after command block registers so use command block address + 8h for XTIDE card.
   * Enable interrupt
    IDE controller can use interrupts to signal when it is ready to transfer data. This makes possible to do other tasks while waiting drive to be ready. That is not useful in MS-DOS but using interrupts frees the bus for any DMA transfers. Polling mode is used when interrupts are disabled. Polling usually gives a little better access times since interrupt handling requires extra processing. There can be some compatibility issues with some old drives when polling is used with block mode transfers.
@@ -138,7 +142,7 @@
    Resumes back to XTIDE Universal BIOS configuration menu.
   * Default boot drive
-   Default drive will be set selected by default when Boot Menu is displayed.
+   Drive to be set selected by default when Boot Menu is displayed.
   * Display drive info  
-   Boot Menu can display some details about the drives in system. Reading this data is slow on XTs so you might want to hide drive information.
+   Boot Menu can display some details about the drives in system. Reading this data might be slow on XTs so you might want to hide drive information.
   * Display ROM boot
    Some old systems have Basic or DOS in ROM. Since most systems don't have either, ROM Boot setting is disabled by default. Enable it if you have use for it.
@@ -175,5 +179,5 @@
    Address (segment) where EEPROM is located.
   * Page size
-   Larger page size will improve write performance but not all EEPROMs support large pages or page writing at all. Byte writing mode will be used when page size is set to 1. Byte writing mode is supported by every EEPROM. Large pages cannot be used with slow CPUs.
+   Larger page size will improve write performance but not all EEPROMs support large pages or page writing at all. Byte writing mode will be used when page size is set to 1. Byte writing mode is supported by every EEPROM. Large pages cannot be flashed with slow CPUs.
   * Generate checksum byte
    PC BIOSes require checksum byte to the end of expansion card BIOS ROMs. Checksum generation can be disabled so any type of binaries can be flashed.
@@ -193,5 +197,5 @@
 == Boot menu hotkeys ==
 
-Keys A to Z work as a hotkeys for boot menu drives. Hotkeys have another benefit: they allow to install DOS from any floppy drive to any hard disks. Select hard disk from menu but do not press Enter. Press any floppy drive hotkey instead to boot from floppy while maintaining selected hard disk translation.
+Keys A to Z work as a hotkeys for boot menu drives. Hotkeys have another benefit: they allow to install DOS from any floppy drive to any hard disk. Select hard disk from menu but do not press Enter. Press any floppy drive hotkey instead to boot from floppy while maintaining selected hard disk translation.
 
 
@@ -204,9 +208,9 @@
   * Drive configuration information is displayed for XTIDE Universal BIOS controlled drives. Information includes:
    * Addressing (Addr.)
-    This can be L-CHS, P-CHS, LBA28 or LBA48. CHS addressing is the old type of addressing method where cylinder, head and sector numbers will be handled separately. Original PC BIOS functions are designed for CHS addressing with maximum  hard disk size being 7.8 GiB (8.4 GB) when some CHS translation method is being used. LBA addressing is modern addressing method where every sector has its own address. There are no cylinders or heads anymore. Enhanced BIOS functions were introduced for LBA drives but they are not supported before Windows 95 (DOS 7). These EBIOS function are not yet supported by XTIDE Universal BIOS. CHS address must be translated to LBA address when using old CHS BIOS functions with LBA addressing.
+    This can be L-CHS, P-CHS, LBA28 or LBA48. CHS addressing is the old type of addressing method where cylinder, head and sector numbers will be handled separately. Original PC BIOS functions are designed for CHS addressing with maximum  hard disk size being 7.8 GiB (8.4 GB). LBA addressing is modern addressing method where every sector has its own address. There are no cylinders or heads anymore. Enhanced BIOS functions were introduced for LBA drives but they are not supported before Windows 95 (DOS 7). These EBIOS function are not yet supported by XTIDE Universal BIOS. CHS address must be translated to LBA address when using old CHS BIOS functions with LBA addressing.
     * L-CHS (known as NORMAL on many old BIOSes) is used for drives <= 504 MiB that can accept the CHS parameters without translation. That makes L-CHS the fastest addressing method.
     * P-CHS (known as LARGE on many old BIOSes) is used for drives from 504 MiB up to 7.8 GiB. This is a bit slower than L-CHS since simple translation is required to make BIOS L-CHS parameters compatible with IDE P-CHS parameters.
-    * LBA28 (28-bit address) allows drive sizes up to 128 GiB (137 GB). L-CHS to LBA translation is more complex and slower than L-CHS to P-CHS conversion.
-    * LBA48 (48-bit address) work just like LBA28 but with 20 more address bits.
+    * LBA28 (28-bit address) allows drive sizes up to 128 GiB (137 GB) but maximum accessible size is 7.8 GiB when old BIOS functions are used. L-CHS to LBA translation is more complex and slower than L-CHS to P-CHS conversion.
+    * LBA48 (48-bit address) work just like LBA28 but with 20 more address bits. This makes possible to use drives with over 128 GiB capacity.
    * Block mode (Block)
     Block size in sectors for block mode transfers. XTIDE Universal BIOS always uses largest supported block size. Block mode is disabled or not supported if this is 1.
@@ -222,5 +226,5 @@
 = IDE controllers on VLB and PCI bus =
 
-16-bit ISA IDE controllers are very simple ISA to PATA adapters and they all perform alike. ISA is not fast enough for anything above PIO-0 transfer method (theoretical maximum 3.3 MB/s).
+16-bit ISA IDE controllers are basically very simple ISA to PATA adapters so they all perform alike. ISA is not fast enough for anything above PIO-0 transfer method (with theoretical maximum of 3.3 MB/s).
 
 VLB and PCI IDE controllers are much more complex since they have an actual controller between bus and IDE drive. This controller can buffer words so CPU can read 32-bits at a time. Later VLB and (all?) PCI controller also offer flow control so they can support PIO modes 3 and 4. Early VLB controller are limited to PIO-2. Later VLB multi I/O cards have two IDE connectors so you should use one of those even if you don't need the other IDE connector.
@@ -252,7 +256,7 @@
 
 When reporting bugs or other problems, please post the following information:
-Computer specs (at least CPU and RAM but details about expansion card and how they are configured might be useful)
-Operating system and version (for example MS-DOS 6.22)
-Hard disk(s) you are using with XTIDE Universal BIOS
-Hard disk(s) not handled by XTIDE Universal BIOS (if any)
-Reset status that boot menu shows if problem is related to specific drive
+  * Computer specs (at least CPU and RAM but details about expansion cards and how they are configured might be useful)
+  * Operating system and version (for example MS-DOS 6.22)
+  * Hard disk(s) you are using with XTIDE Universal BIOS
+  * Hard disk(s) not handled by XTIDE Universal BIOS (if any)
+  * Reset status that boot menu shows if problem is related to specific drive